> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create taxation items for an invoice

POST https://rest.test.zuora.com/v1/invoices/{invoiceKey}/taxation-items
Content-Type: application/json

Creates taxation items for an invoice.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/invoices/post-inv-taxation-items

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `invoiceKey` (string, required) — The unique ID or number of an invoice. For example, 8a8082e65b27f6c3015ba45ff82c7172 or INV00000001.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTTaxationItemList.

- `taxationItems` (list of POSTTaxationItemTypeForInvoice, optional) — Container for taxation items.

## Response

### 200

OK

- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `taxationItems` (list of GETTaxationItemTypewithSuccess, optional) — Container for taxation items.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### POSTTaxationItemTypeForInvoice

Container for custom fields of a Taxation Item object.

- `invoiceItemId` (string, required) — The ID of the invoice associated with the taxation item.
- `jurisdiction` (string, required) — The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city.
- `name` (string, required) — The name of taxation.
- `taxAmount` (string, required) — The amount of the taxation item in the invoice item.
- `taxDate` (date, required) — The date that the tax is applied to the invoice item, in `yyyy-mm-dd` format.
- `taxRate` (string, required) — The tax rate applied to the invoice item.
- `taxRateType` (enum, required) — The type of the tax rate applied to the invoice item.
  - Allowed values: `Percentage`, `FlatFee`
- `exemptAmount` (string, optional) — The calculated tax amount excluded due to the exemption.
- `financeInformation` (PostTaxationItemTypeForInvoiceFinanceInformation, optional) — Container for the finance information related to the taxation item.
- `locationCode` (string, optional) — The identifier for the location based on the value of the `taxCode` field.
- `taxCode` (string, optional) — The tax code identifies which tax rules and tax rates to apply to a specific invoice item.
- `taxCodeDescription` (string, optional) — The description of the tax code.
- `taxMode` (enum, optional) — The tax mode of the invoice item, indicating whether the amount of the invoice item includes tax.
  - Allowed values: `TaxInclusive`, `TaxExclusive`
- `taxRateDescription` (string, optional) — The description of the tax rate.

### GETTaxationItemTypewithSuccess

Container for custom fields of a Taxation Item object.

- `createdById` (string, optional) — The ID of the Zuora user who created the taxation item.
- `createdDate` (string, optional) — The date and time when the taxation item was created in the Zuora system, in `yyyy-mm-dd hh:mm:ss` format.
- `exemptAmount` (double, optional) — The calculated tax amount excluded due to the exemption.
- `financeInformation` (GetTaxationItemTypewithSuccessFinanceInformation, optional) — Container for the finance information related to the taxation item.
- `id` (string, optional) — The ID of the taxation item.
- `invoiceItemId` (string, optional) — The ID of the invoice associated with the taxation item.
- `jurisdiction` (string, optional) — The jurisdiction that applies the tax or VAT. This value is typically a state, province, county, or city.
- `locationCode` (string, optional, nullable) — The identifier for the location based on the value of the `taxCode` field.
- `name` (string, optional) — The name of the taxation item.
- `taxAmount` (double, optional) — The amount of the tax applied to the invoice.
- `taxCode` (string, optional) — The tax code identifies which tax rules and tax rates to apply to a specific invoice.
- `taxCodeDescription` (string, optional, nullable) — The description of the tax code.
- `taxDate` (date, optional) — The date when the tax is applied to the invoice.
- `taxMode` (enum, optional) — The tax mode of the invoice item, indicating whether the amount of the invoice item includes tax.
  - Allowed values: `TaxInclusive`, `TaxExclusive`
- `taxRate` (double, optional) — The tax rate applied to the invoice.
- `taxRateDescription` (string, optional, nullable) — The description of the tax rate.
- `taxRateType` (enum, optional) — The type of the tax rate applied to the invoice.
  - Allowed values: `Percentage`, `FlatFee`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the taxation item.
- `updatedDate` (string, optional) — The date and time when the taxation item was last updated, in `yyyy-mm-dd hh:mm:ss` format.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### PostTaxationItemTypeForInvoiceFinanceInformation

Container for the finance information related to the taxation item.

- `accountsReceivableAccountingCode` (string, optional) — The accounting code for accounts receivable.
- `salesTaxPayableAccountingCode` (string, optional) — The accounting code for the sales taxes payable.

### GetTaxationItemTypewithSuccessFinanceInformation

Container for the finance information related to the taxation item.

- `accountsReceivableAccountingCode` (string, optional) — The accounting code for accounts receivable.
- `accountsReceivableAccountingCodeType` (string, optional) — The type of the accounting code for accounts receivable.
- `salesTaxPayableAccountingCode` (string, optional) — The accounting code for the sales taxes payable.
- `salesTaxPayableAccountingCodeType` (string, optional) — The type of the accounting code for the sales taxes payable.

## Examples

**Request**

```json
{
  "taxationItems": [
    {
      "invoiceItemId": "402890555a7e9791015a879f064d0055",
      "jurisdiction": "CALIFORNIA",
      "name": "STATE TAX",
      "taxAmount": "0.1",
      "taxDate": "2016-09-30",
      "taxRate": "0.0625",
      "taxRateType": "Percentage",
      "exemptAmount": "0",
      "financeInformation": {
        "accountsReceivableAccountingCode": "Check",
        "salesTaxPayableAccountingCode": "Check"
      },
      "locationCode": "06",
      "taxCode": "ServiceTaxCode",
      "taxCodeDescription": "This is tax code description!",
      "taxMode": "TaxExclusive",
      "taxRateDescription": "This is tax rate description!"
    }
  ]
}
```

**Response**

```json
{
  "success": true,
  "taxationItems": [
    {
      "createdById": "402881e522cf4f9b0122cf5d82860002",
      "createdDate": "2017-03-01 10:08:43",
      "exemptAmount": 0,
      "financeInformation": {
        "accountsReceivableAccountingCode": "Check",
        "accountsReceivableAccountingCodeType": "Cash",
        "salesTaxPayableAccountingCode": "Check",
        "salesTaxPayableAccountingCodeType": "Cash"
      },
      "id": "402890555a7e9791015a87a072880062",
      "invoiceItemId": "402890555a7e9791015a879f064d0055",
      "jurisdiction": "CALIFORNIA",
      "locationCode": "06",
      "name": "STATE TAX",
      "taxAmount": 0.1,
      "taxCode": "ServiceTaxCode",
      "taxCodeDescription": "This is tax code description!",
      "taxDate": "2016-09-30",
      "taxMode": "TaxExclusive",
      "taxRate": 0.0625,
      "taxRateDescription": "This is tax rate description!",
      "taxRateType": "Percentage",
      "updatedById": "402881e522cf4f9b0122cf5d82860002",
      "updatedDate": "2017-03-01 10:08:43"
    }
  ]
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items"

payload = { "taxationItems": [
        {
            "invoiceItemId": "402890555a7e9791015a879f064d0055",
            "jurisdiction": "CALIFORNIA",
            "name": "STATE TAX",
            "taxAmount": "0.1",
            "taxDate": "2016-09-30",
            "taxRate": "0.0625",
            "taxRateType": "Percentage",
            "exemptAmount": "0",
            "financeInformation": {
                "accountsReceivableAccountingCode": "Check",
                "salesTaxPayableAccountingCode": "Check"
            },
            "locationCode": "06",
            "taxCode": "ServiceTaxCode",
            "taxCodeDescription": "This is tax code description!",
            "taxMode": "TaxExclusive",
            "taxRateDescription": "This is tax rate description!"
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"taxationItems":[{"invoiceItemId":"402890555a7e9791015a879f064d0055","jurisdiction":"CALIFORNIA","name":"STATE TAX","taxAmount":"0.1","taxDate":"2016-09-30","taxRate":"0.0625","taxRateType":"Percentage","exemptAmount":"0","financeInformation":{"accountsReceivableAccountingCode":"Check","salesTaxPayableAccountingCode":"Check"},"locationCode":"06","taxCode":"ServiceTaxCode","taxCodeDescription":"This is tax code description!","taxMode":"TaxExclusive","taxRateDescription":"This is tax rate description!"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items"

	payload := strings.NewReader("{\n  \"taxationItems\": [\n    {\n      \"invoiceItemId\": \"402890555a7e9791015a879f064d0055\",\n      \"jurisdiction\": \"CALIFORNIA\",\n      \"name\": \"STATE TAX\",\n      \"taxAmount\": \"0.1\",\n      \"taxDate\": \"2016-09-30\",\n      \"taxRate\": \"0.0625\",\n      \"taxRateType\": \"Percentage\",\n      \"exemptAmount\": \"0\",\n      \"financeInformation\": {\n        \"accountsReceivableAccountingCode\": \"Check\",\n        \"salesTaxPayableAccountingCode\": \"Check\"\n      },\n      \"locationCode\": \"06\",\n      \"taxCode\": \"ServiceTaxCode\",\n      \"taxCodeDescription\": \"This is tax code description!\",\n      \"taxMode\": \"TaxExclusive\",\n      \"taxRateDescription\": \"This is tax rate description!\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"taxationItems\": [\n    {\n      \"invoiceItemId\": \"402890555a7e9791015a879f064d0055\",\n      \"jurisdiction\": \"CALIFORNIA\",\n      \"name\": \"STATE TAX\",\n      \"taxAmount\": \"0.1\",\n      \"taxDate\": \"2016-09-30\",\n      \"taxRate\": \"0.0625\",\n      \"taxRateType\": \"Percentage\",\n      \"exemptAmount\": \"0\",\n      \"financeInformation\": {\n        \"accountsReceivableAccountingCode\": \"Check\",\n        \"salesTaxPayableAccountingCode\": \"Check\"\n      },\n      \"locationCode\": \"06\",\n      \"taxCode\": \"ServiceTaxCode\",\n      \"taxCodeDescription\": \"This is tax code description!\",\n      \"taxMode\": \"TaxExclusive\",\n      \"taxRateDescription\": \"This is tax rate description!\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"taxationItems\": [\n    {\n      \"invoiceItemId\": \"402890555a7e9791015a879f064d0055\",\n      \"jurisdiction\": \"CALIFORNIA\",\n      \"name\": \"STATE TAX\",\n      \"taxAmount\": \"0.1\",\n      \"taxDate\": \"2016-09-30\",\n      \"taxRate\": \"0.0625\",\n      \"taxRateType\": \"Percentage\",\n      \"exemptAmount\": \"0\",\n      \"financeInformation\": {\n        \"accountsReceivableAccountingCode\": \"Check\",\n        \"salesTaxPayableAccountingCode\": \"Check\"\n      },\n      \"locationCode\": \"06\",\n      \"taxCode\": \"ServiceTaxCode\",\n      \"taxCodeDescription\": \"This is tax code description!\",\n      \"taxMode\": \"TaxExclusive\",\n      \"taxRateDescription\": \"This is tax rate description!\"\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items', [
  'body' => '{
  "taxationItems": [
    {
      "invoiceItemId": "402890555a7e9791015a879f064d0055",
      "jurisdiction": "CALIFORNIA",
      "name": "STATE TAX",
      "taxAmount": "0.1",
      "taxDate": "2016-09-30",
      "taxRate": "0.0625",
      "taxRateType": "Percentage",
      "exemptAmount": "0",
      "financeInformation": {
        "accountsReceivableAccountingCode": "Check",
        "salesTaxPayableAccountingCode": "Check"
      },
      "locationCode": "06",
      "taxCode": "ServiceTaxCode",
      "taxCodeDescription": "This is tax code description!",
      "taxMode": "TaxExclusive",
      "taxRateDescription": "This is tax rate description!"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"taxationItems\": [\n    {\n      \"invoiceItemId\": \"402890555a7e9791015a879f064d0055\",\n      \"jurisdiction\": \"CALIFORNIA\",\n      \"name\": \"STATE TAX\",\n      \"taxAmount\": \"0.1\",\n      \"taxDate\": \"2016-09-30\",\n      \"taxRate\": \"0.0625\",\n      \"taxRateType\": \"Percentage\",\n      \"exemptAmount\": \"0\",\n      \"financeInformation\": {\n        \"accountsReceivableAccountingCode\": \"Check\",\n        \"salesTaxPayableAccountingCode\": \"Check\"\n      },\n      \"locationCode\": \"06\",\n      \"taxCode\": \"ServiceTaxCode\",\n      \"taxCodeDescription\": \"This is tax code description!\",\n      \"taxMode\": \"TaxExclusive\",\n      \"taxRateDescription\": \"This is tax rate description!\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["taxationItems": [
    [
      "invoiceItemId": "402890555a7e9791015a879f064d0055",
      "jurisdiction": "CALIFORNIA",
      "name": "STATE TAX",
      "taxAmount": "0.1",
      "taxDate": "2016-09-30",
      "taxRate": "0.0625",
      "taxRateType": "Percentage",
      "exemptAmount": "0",
      "financeInformation": [
        "accountsReceivableAccountingCode": "Check",
        "salesTaxPayableAccountingCode": "Check"
      ],
      "locationCode": "06",
      "taxCode": "ServiceTaxCode",
      "taxCodeDescription": "This is tax code description!",
      "taxMode": "TaxExclusive",
      "taxRateDescription": "This is tax rate description!"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/invoices/invoiceKey/taxation-items")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```